Name "Faerion IRC Daemon, version 1.17.5"
ComponentText "This will set up Faerion IRC Daemon"
DirText "This will extract Faerion IRC Daemon files to a specified location. No system parameter is changed, you will need to read files in the doc/ directory to learn about the configuration process."
OutFile faerion-1.17.5.exe
InstallDir $PROGRAMFILES\ForestNet\Faerion
InstallDirRegKey HKCU "Software\ForestNet\Faerion" ""
ShowInstDetails show

InstType Standard

Section "Standard"
	SectionIn 1-3

	SetOutPath "$INSTDIR"
	SetOverwrite on
	File "src\faerion.exe"
	File "src\md5\md5.exe"
	SetOverwrite off
	File /oname=ircd.conf "doc\example.conf"
	File "c:\winnt\system32\libz.dll"

	SetOutPath "$INSTDIR\codepage"
	SetOverwrite on
	File "src\codepage\cp???"
	File "src\codepage\cp????"
	File "src\codepage\koi8?"
	File "src\codepage\iso8859-5"
	File "src\codepage\mac"
	File "src\codepage\translit"

	SetOutPath "$INSTDIR\codepage\source"
	SetOverwrite on
	File "src\codepage\*.enc"
	File "src\codepage\mkenc.exe"

	SetOutPath "$INSTDIR\doc"
	SetOverwrite on
	File "doc\features"
	File "doc\conf.doc"
	File "license" "known_bugs" "changes" "todo"
	
	WriteUninstaller "uninstall.exe"
	WriteRegStr HKCU "Software\ForestNet\Faerion" "" "$INSTDIR"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Faerion" "DisplayName" "Faerion IRC Daemon"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Faerion" "UninstallString" '"$INSTDIR\uninstall.exe"'

	MessageBox MB_OK "Faerion (ver. 1.17.5) has been installed to your system.  You can find all the necessary documentation in the `doc' subfolder of your installation.  Currently, the daemon is ready to run as a stand-alone local server, just launch faerion.exe and connect to localhost:6667.  If you find any bugs or have a suggestion, send them to <ircd@forestnet.org>.  To have the latest version, check <http://ircd.forestnet.org/> from time to time.  Thank you for your interest in Faerion."
	; Exec "explorer.exe $INSTDIR\Specs"
SectionEnd


; uninstall
UninstallText "This will uninstall Faerion IRC Daemon. Hit next to continue."

Section "Uninstall"
	DeleteRegKey HKCU "Software\ForestNet\Faerion"
	RMDir /r $INSTDIR
SectionEnd
