/* m_away.c -- change a client's away status;
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 */

#ifndef lint
static char cvsid[] = "$Id: m_away.c,v 1.2 2002/05/31 12:17:43 hex Exp $";
#endif

#include <string.h> /* strdup() */
#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"


/* parv[0] = sender prefix, parv[1] = away message */
int m_away(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	int was_away = IsAway(sptr);

	/* this is a local-use-only command */
	if (check_registered_user(sptr) || !MyClient(sptr))
		return 0;

	if (sptr->away) {
		free((void*)sptr->away);
		sptr->away = (char*)NULL;
	}

	if (parc > 1 && !BadPtr(parv[1])) {
		if (strlen(parv[1]) > (size_t) TOPICLEN)
			parv[1][TOPICLEN] = 0;
		sptr->away = strdup(parv[1]);
	}

	if (sptr->away && !was_away) {
		sptr->umodes |= UMODE_GONE;
		sendto_one(sptr, rpl_str(RPL_NOWAWAY), me.name, parv[0]);
		sendto_serv_butone(cptr, ":%s MODE %s :+G", parv[0], parv[0]);
	}
	else if (!sptr->away && was_away) {
		sptr->umodes &= ~UMODE_GONE;
		sendto_one(sptr, rpl_str(RPL_UNAWAY), me.name, parv[0]);
		sendto_serv_butone(cptr, ":%s MODE %s :-G", parv[0], parv[0]);
	}

	return 0;
}
