/* m_die.c -- server shutdown
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 */

#ifndef lint
static char rcsid[] = "$Id: m_die.c,v 1.3 2002/06/14 08:18:13 hex Exp $";
#endif

#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"

int m_die(aClient *cptr, aClient *sptr, int  parc, char *parv[])
{
	aClient *acptr;
	int i;
	char *pass = NULL;

	if (check_registered(sptr) || !MyClient(sptr))
		return 0;

	if (!OPIsAdmin(sptr)) {
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return 0;
	}

	if ((pass = find_diepass())) {
		if (parc < 2) {
			sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
				me.name, parv[0], "DIE");
			return 0;
		}

		if (strcmp(pass, parv[1])) {
			sendto_one(sptr, err_str(ERR_PASSWDMISMATCH),
				me.name, parv[0]);
			return 0;
		}
	}

	sendto_ops("Server Terminating by request of %s", parv[0]);

	for (i = 0; i <= highest_fd; i++) {
		if (!(acptr = local[i]))
			continue;

		if (IsClient(acptr))
			sendto_one(acptr, ":%s NOTICE %s :Server Terminating."
				" %s", me.name, acptr->name,
				get_client_name(sptr, TRUE));

		else if (IsServer(acptr))
			sendto_one(acptr, ":%s ERROR :Terminated by %s",
				me.name, get_client_name(sptr, TRUE));
	}
	s_die();
	return 0;
}

#ifdef _WIN32
/*
 * Added to let the local console shutdown the server without just
 * calling exit(-1), in Windows mode.  -Cabal95
 */
int localdie(void)
{
	aClient *acptr;
	int i;

	for (i = 0; i <= highest_fd; i++) {
		if (!(acptr = local[i]))
			continue;

		if (IsClient(acptr))
			sendto_one(acptr, ":%s NOTICE %s :Server Terminated "
				"by local console", me.name, acptr->name);

		else if (IsServer(acptr))
			sendto_one(acptr, ":%s ERROR :Terminated by "
				"local console", me.name);
	}
	s_die();
	return 0;
}
#endif



