/* m_info.c -- sends information about the daemon
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 */

#ifndef lint
static char rcsid[] = "$Id: m_info.c,v 1.9 2002/07/11 17:47:37 hex Exp $";
#endif

#include "config.h"
#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"
#include "common.h"

static char *infotext[] = {
"IRC",
"Based on the original code written by Jarkko Oikarinen",
"Copyright 1988, 1989, 1990, 1991 University of Oulu, Computing Center",
" ",
"This program is free software; you can redistribute it and/or",
"modify it under the terms of the GNU General Public License as",
"published by the Free Software Foundation; either version 1, or",
"(at your option) any later version.",
" ",
"The following people participated in the developement of faerion:",
"hex (hex@forestnet.org), draky (draky@forestnet.org),",
"Borg88 (borg88@go2.pl)",
" ",
0
};


/* parv[0] = sender prefix, parv[1] = servername */
int m_info(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	char **text = infotext;

	if (check_registered(sptr))
		return 0;

	if (!BadPtr(server_mask) && parc > 1 && !IsPrivileged(sptr)) {
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return 0;
	}

	if (hunt_server(cptr, sptr, ":%s INFO :%s", 1, parc, parv)
		!= HUNTED_ISME) return 0;

	while (*text)
		sendto_one(sptr, rpl_str(RPL_INFO), me.name, parv[0], *text++);

	if (IsAnOper(sptr)) {
		sendto_one(sptr, ":%s %d %s :Runtime configuration (read from "
			"%s):", me.name, RPL_INFO, parv[0], configfile);
		sendto_one(sptr, ":%s %d %s :Network Name     : %s",
			me.name, RPL_INFO, parv[0],
			network_name ? network_name : "not set");
		sendto_one(sptr, ":%s %d %s :K-Line address   : %s",
			me.name, RPL_INFO, parv[0],
			kline_address ? kline_address : "not set");
		sendto_one(sptr, ":%s %d %s :Contact URL      : %s",
			me.name, RPL_INFO, parv[0],
			contact_url ? contact_url : "not set");
		sendto_one(sptr, ":%s %d %s :Services host    : %s",
			me.name, RPL_INFO, parv[0],
			services_host ? services_host : "not set");
		if (!BadPtr(services_host))
			sendto_one(sptr, ":%s %d %s :Services nicks   : %s, %s, "
				"%s, %s", me.name, RPL_INFO, parv[0],
				ns_nick, cs_nick, ms_nick, os_nick);
		sendto_one(sptr, ":%s %d %s :Server mask      : %s",
			me.name, RPL_INFO, parv[0],
			server_mask ? server_mask : "not set");
		sendto_one(sptr, ":%s %d %s :Default UMode    : +%s",
			me.name, RPL_INFO, parv[0],
			get_default_umode());
		sendto_one(sptr, ":%s %d %s :Nick Change Delay: %d",
			me.name, RPL_INFO, parv[0],
			nickchange_delay);
		sendto_one(sptr, ":%s %d %s :ShowConnectInfo  : %s",
			me.name, RPL_INFO, parv[0],
			show_connect_info ? "yes" : "no");
		sendto_one(sptr, ":%s %d %s :MOTD is sent     : %s",
			me.name, RPL_INFO, parv[0],
			force_motd ? "automatically" : "by request");
		/*
		sendto_one(sptr, ":%s %d %s :Codepage Locaton : %s",
			me.name, RPL_INFO, parv[0],
			codepage_path ? codepage_path : "unknown.");
		*/
		sendto_one(sptr, ":%s %d %s : ", me.name, RPL_INFO, parv[0]);
	}

	sendto_one(sptr, rpl_str(RPL_INFO), me.name, parv[0], "");
	sendto_one(sptr, ":%s %d %s :Birth Date: %s", me.name,
		RPL_INFO, parv[0], creation);
	sendto_one(sptr, ":%s %d %s :On-line since %s", me.name,
		RPL_INFO, parv[0], myctime(me.firsttime));
	sendto_one(sptr, rpl_str(RPL_ENDOFINFO), me.name, parv[0]);

	return 0;
}
