/* m_rehash.c -- update server configuration, reset some settings;
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 */

#ifndef lint
static char rcsid[] = "$Id: m_rehash.c,v 1.6 2002/06/14 08:22:48 hex Exp $";
#endif

#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"

/* added remote rehash, parv[1] - remote server -- Borg88 */
int m_rehash(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	if (check_registered(sptr))
		return 0;

	if (!IsAnOper(sptr)) {
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return(0);
	}

	if (parc > 1) {
		if (!IsOper(sptr)) {
			sendto_one(sptr, err_str(ERR_NOPRIVILEGES),
				me.name, parv[0]);
			return 0;
		}

		if (hunt_server(cptr, sptr, ":%s REHASH %s", 1, parc, parv)
			!= HUNTED_ISME) return 0;
	}

	oper_closed = 0;

	/* remove unused conversion tables */
	codepage_purge();

	sendto_one(sptr, rpl_str(RPL_REHASHING), me.name, parv[0], configfile);
	sendto_ops("%s is rehashing Server config file", parv[0]);
#ifdef USE_SYSLOG
	syslog(LOG_INFO, "REHASH From %s\n", get_client_name(sptr, FALSE));
#endif
	return rehash(cptr, sptr, (parc > 1) ? ((*parv[1] == 'q') ? 2 : 0) : 0);
}
