/* m_time.c -- get a server's local time;
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 */

#ifndef lint
static char rcsid[] = "$Id: m_time.c,v 1.4 2002/06/14 18:07:36 hex Exp $";
#endif

#include <time.h>
#include "options.h"
#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"
#include "common.h"

/* parv[0] = sender prefix, parv[1] = servername */
int m_time(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	time_t t;

	if (check_registered_user(sptr))
		return 0;

	if (parc > 1 && BadPtr(parv[1]))
		parc = 1;

	if (!BadPtr(server_mask) && parc > 1 && !allow_forward(sptr, parv[1])) {
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return 0;
	}

	if (hunt_server(cptr, sptr, ":%s TIME %s", 1, parc, parv)
		!= HUNTED_ISME) return 0;

	t = time(0);

	sendto_one(sptr, rpl_str(RPL_TIME), me.name,
		parv[0], me.name, ctime(&t));

	return 0;
}
