/* m_version.c -- get a server's version number;
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 */

#ifndef lint
static char rcsid[] = "$Id: m_version.c,v 1.23 2002/07/14 12:59:32 hex Exp $";
#endif

#include "options.h"
#include "struct.h"
#include "send.h"
#include "numeric.h"
#include "h.h"
#include "common.h"

const char *version = "faerion-1.17.5";
const char *creation = __DATE__ " " __TIME__;

/* parv[0] = sender prefix, parv[1] = remote server */
int m_version(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	extern char serveropts[];

	if (check_registered(sptr))
		return 0;

	if (!BadPtr(server_mask) && parc > 1 && !allow_forward(sptr, parv[1])) {
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return 0;
	}

	if (hunt_server(cptr, sptr, ":%s VERSION :%s", 1, parc, parv)
		!= HUNTED_ISME) return 0;

	sendto_one(sptr, rpl_str(RPL_VERSION), me.name, parv[0], version,
		debugmode, me.name, serveropts
#ifdef USE_CASETABLES
		, casetable
#endif
		);

	return 0;
}
