/* m_zline.c -- deny connections matching an IP address;
 * Copyright (C) 2001-2002, ForestNet IRC Network
 * This is a free software; see file `license' for details.
 */

#ifndef lint
static char rcsid[] = "$Id: m_zline.c,v 1.4 2002/06/14 08:33:40 hex Exp $";
#endif

#include "struct.h"
#include "numeric.h"
#include "msg.h"
#include "h.h"

int m_zline(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
	char *ipmask;
	aClient *acptr = NULL;

	if (check_registered(sptr))
		return 0;

	if (MyClient(sptr) && (!OPIsAnOper(sptr)
	|| (IsLocOp(sptr) && parc > 2))) {
		sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
		return 0;
	}

	if (parc < 2) {
		send_syntax(sptr, MSG_ZLINE, "ZLINE {hostmask,nick} [server]");
		return 0;
	}

	/* validate nick-based z-lines */
	if (parc == 2 && !strchr(parv[1], '.')) {
		if (!(acptr = find_person(parv[1], NULL))) {
			sendto_one(sptr, err_str(ERR_NOSUCHNICK), me.name,
				sptr->name, parv[1]);
			return 0;
		}

		if (hunt_server(cptr, sptr, ":%s ZLINE %s", 1, parc, parv)
			!= HUNTED_ISME) return 0;
	}

	else {
		if (check_ipmask(parv[1])) {
			send_syntax(sptr, MSG_ZLINE, "ZLINE {hostmask,nick} "
				"[server]");
			return 0;
		}

		if (hunt_server(cptr, sptr, ":%s ZLINE %s %s", 2, parc, parv)
			!= HUNTED_ISME) return 0;
	}

	ipmask = acptr ? inetntoa((char *)&acptr->ip) : parv[1];

	sendto_one(sptr, "NOTICE %s :Temp Z-Line %s is now added.",
		parv[0], ipmask);

	sendto_ops("%s added a temp Z-Line %s", parv[0], ipmask);

	add_temp_conf(CONF_ZAP, ipmask, 0, 0, 0, 0, 1);
	check_pings(time(NULL), 1);
	return 0;
}
