/************************************************************************
 *   IRC - Internet Relay Chat, win32.c
 *   Copyright (C) 1996 Daniel Hazelbaker
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef lint
static char rcsid[] = "$Id: win32.c,v 1.4 2002/06/14 08:33:40 hex Exp $";
#endif

#include "common.h"
#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <io.h>
#include <fcntl.h>
#include "struct.h"
#include "sys.h"
#include <sys/types.h>
#include <sys/stat.h>
#include "h.h"

#include "resource.h"

BOOL InitApplication(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
LRESULT CALLBACK  FrameWndProc(HWND, UINT, WPARAM, LPARAM);

extern void SocketLoop(void *dummy), s_rehash(), do_dns_async(HANDLE id);
extern int localdie(void), InitwIRCD(int argc, char *argv[]);

HINSTANCE   hInst; /* current instance */
char        szAppName[] = APPNAME; /* The name of this application */
char        szTitle[]   = APPNAME; /* The title bar text */
HWND        hwIRCDWnd=NULL, hCio=NULL;
HANDLE      hMainThread = 0;


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	int argc=1;
	char *s, *argv[20], String[128];

	if (!hPrevInstance)
		if (!InitApplication(hInstance))
			return (FALSE);

	if (!InitInstance(hInstance, nCmdShow))
		return (FALSE);

	if (*(s = lpCmdLine)) {
		argv[argc++] = s;
		while ((s = strchr(s, ' ')) != NULL) {
			while ( *s == ' ' ) *s++ = 0;
				argv[argc++] = s;
		}
	}

	argv[argc] = NULL;
	if (InitwIRCD(argc, argv) != 1)
		return FALSE;

	hMainThread = (HANDLE)_beginthread(SocketLoop, 0, NULL);

	/* Main message loop */
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (msg.wParam);
}


BOOL InitApplication(HINSTANCE hInstance)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = (WNDPROC)FrameWndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = 0;
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_GRAYTEXT);
	wc.lpszMenuName  = szAppName;
	wc.lpszClassName = szAppName;

	if (!RegisterClass(&wc)) return 0;

	return 1;
}


BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;
	WSADATA WSAData;

	if (WSAStartup(MAKEWORD(1, 1), &WSAData) != 0) {
		MessageBox(NULL, APPNAME " Init Error", "Unable to initialize WinSock DLL", MB_OK);
		return FALSE;
	}

	hInst = hInstance; /* Store instance handle in our global variable  */

	hWnd = CreateWindow(szAppName, szTitle, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

	return hWnd ? TRUE : FALSE;
}


LRESULT CALLBACK FrameWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	switch (message) {
		case WM_DESTROY:
			localdie(); /* Never returns */
			PostQuitMessage(0);
			break;

		case WM_ENDSESSION:
			localdie(); /* Never returns */
			return(0);

		default:
			return (DefWindowProc(hWnd, message, wParam, lParam));
	}

	return 0;
}
